;-------------------------------------------------
; 樠 誨  뢮   ࠭
;-------------------------------------------------
init_mouse:
	xor	a
	rst	30h
	jr	show_mouse


;-------------------------------------------------
; 뢥  誨
;-------------------------------------------------
show_mouse:
	ld	a,1
	rst	30h
	ret


;-------------------------------------------------
;   誨
;-------------------------------------------------
hide_mouse:
	ld	a,2
	rst	30h
	ret


;-------------------------------------------------
;   ଠ  誥
;-------------------------------------------------
get_mouse_info:
	ld	a,3			;  . 誨
	rst	30h
	ret


;-------------------------------------------------
; ,   ⮭ 誨
;-------------------------------------------------
get_fire:
	call	get_mouse_info
	and	3
	jr	nz,$-5			; ⮭ 
	ret






;---------------------------------------------------------------------
; ࠡ⪠  ⮭ 誨   
;
; 室: hl=Y/X ⥪. न 誨.
;       d=  ⮭
;---------------------------------------------------------------------
buttons_press:
	ld	a,d
	ld	(buttons_bits),a	; .   ⮭
	ld	a,h
	cp	27			;  ࠭ ᯨ᪠
	jp	nc,event_keybar		;   comline  key-
	or	a			; 0- ப
	jp	z,main_menu		; ਧ. 
	call	test_show_panels	;   ० . 
	ret	z
	call	mouse_set_active_panel	; . 誮 . 
	ld	a,(format_mode)		; ଠ . 
	and	form_info+form_qview
	ret	nz			; info, qviev
	ld	a,h			; Y न 誨
	cp	2			;  ࠭ ᯨ᪠
	jp	c,event_title		;    
	sub	2
	ld	b,l			; . X न
	ld	l,a			; Y न 誨
	ld	h,0
	;
	ld	de,(all_files)		; ᫮ 䠩  
	ld	a,e
	or	d
	jp	z,get_fire		;   "" ⮭
	ld	a,(cur_panel)		; ⥪. . 
	ld	c,a			; 0=, 80h=ࠢ
	ld	a,(format_mode)		; ଠ . 
	bit	0,a			; full, full-ᯥ
	jr	nz,event_set__		; 祣  
	push	de
	call	event_calc_pointer	; ᫨ . 㪠⥫
	pop	de
event_set__:
	; hl=. 㪠⥫  . 誨
	; de=all_files
	call	cmphlde			; ࠢ hl  de
	jr	nc,event_set_end	; 㪠⥫   ᯨ᪠
	; 誠  । ᯨ᪠ (  ⮬  )
	call	A0E12_			;  . 㪠⥫
	ld	a,(buttons_bits)	;   ⮭
	bit	1,a			;  ?
	jr	nz,button_left		; 
	; ⠢/ 뤥 䠩
	call	A0E13
	jp	get_fire		;   "" ⮭
	;
	; 㪠⥫   ᯨ᪠
event_set_end:
	dec	de
	ex	de,hl			; hl = all_files-1
	call	A0E12_			;  . 㪠⥫
	jp	get_fire		;   "" ⮭
	;
button_left:
	call	get_fire
	ei
	ld	b,9			; 
	push	bc
	call	get_mouse_info		; ⥭ ﭨ 誨
	pop	bc
	jr	nz,double_press		;  
	halt
	djnz	$-8
	ret
	;  
double_press:
	xor	a
	ld	(MSbutt),a		; .  ⮭
	jp	Press_Enter		; enter.asm





;-----------------------------------------------------------
; ᫥  㪠⥫  न⠬ 誨
;  "⪮"  "।" ଠ⮢ .
;
; 室:  a=ଠ 
;       hl=Y न 誨
;        b=X न 誨
;        c=⥪. .  (0=, 80h=ࠢ)
; 室: hl=. 㪠⥫
;-----------------------------------------------------------
event_calc_pointer:
	ld	de,files_per_colon	; 25 䠩  
	and	form_brief
	ld	a,b			; X न
	jr	z,event_medium__
	; "⪨" ଠ
	dec	c			; .   ?
	inc	c
	;  
	ld	c,14			; 砫 । 
	ld	b,27			; 砫 ࠢ 
	jr	z,event_calc__		; , 
	; ࠢ 
	ld	c,54			; 砫 । 
	ld	b,67			; 砫 ࠢ 
event_calc__:
	cp	c			; 砫 । 
	ret	c
	add	hl,de			; .誨 + 䠩  
event_calc1__:
	cp	b			; 砫 ࠢ 
	ret	c
	add	hl,de
	ret
	;
	; "।" ଠ
event_medium__:
	dec	c			; .   ?
	inc	c
	;  
	ld	b,20			; 砫 । 
	jr	z,event_calc1__		; , 
	; ࠢ 
	ld	b,60			; 砫 । 
	jr	event_calc1__



;-----------------------------------------------------------
; ⠭ 誮 ⨢ 
;
; 室: hl=Y/X न
; 室: h=Y ४. न
;-----------------------------------------------------------
mouse_set_active_panel:
	ld	a,(cur_panel)		; 0=, 80h=ࠢ
	or	a
	ld	a,l
	jr	nz,mouse_set__		; . ࠢ
	cp	40			; 砫 ࠢ 
	call	nc,mouse_set_panel	; . . 
	ret
mouse_set__:
	cp	40			; 砫 ࠢ 
	call	c,mouse_set_panel	; . . 
	ret
	;
mouse_set_panel:
	push	hl			; . न 誨
	ld	hl,D48B1		; 䫠 ᨨ
	ld	(hl),false		; .  path-ப
	push	hl
	call	clear_pointer		;  㪠⥫
	call	prn_up_path		; 뢮  ⥪.   ᨨ
	call	change_panel		; ᬥ . 
	pop	hl
	ld	(hl),true		;  path-ப
	call	prn_up_path		; 뢮  ⥪.   ᨥ
	call	print_compath		; 뢮   -ப
	pop	hl
	ret




;-----------------------------------------------------------
; ࠡ⪠ 誨  ⫥ 
;
; 室: hl=Y/X ⥪. न 誨
;-----------------------------------------------------------
event_title:
	ld	a,(buttons_bits)	;   ⮭
	bit	0,a			; ࠢ ⮭ ?
	jr	nz,event_title_right	; 
	ld	a,l			; X न
	cp	1			; 㪢 ஢
	jp	z,select_left_drive	;  롮 ᪮
	cp	41			; 㪢 ஢
	jp	z,select_right_drive	;  롮 ᪮
	cp	2			;   
	jr	z,event_title_sort
	cp	42			;  ࠢ 
	jr	z,event_title_sort
	; ⥫  ப 
	call	up			; 㪠⥫  ப 
	jr	event_title_wait	; প ६. 㪠⥫
	;
; ⠭ ࠭楩
event_title_right:
	call	page_up			; PageUp
	call	get_fire
	jr	event_title_wait






;-----------------------------------------------------------
;  ப , ᫨ 誠  27- ப
;-----------------------------------------------------------
event_footerline:
	call	test_show_panels	;   ० . 
	ret	z
	push	bc
	call	mouse_set_active_panel	; . 誮 . 
	pop	bc
	bit	0,c			; ࠢ ⮭ ?
	jr	nz,event_foot_right	; 
	; ⥫  ப 
	call	down
event_title_wait:
	call	show_pointer		; 뢥 㪠⥫ (  뢮 up/down)
	ei
	halt
	halt
	halt
	ret
	;
; ⠭ ࠭楩
event_foot_right:
	call	page_down		; PageDown
	call	get_fire
	jr	event_title_wait




;-----------------------------------------------------------
; ࠡ⪠ ᨬ "५" ஢ 
;-----------------------------------------------------------
event_title_sort:
	ld	hl,sort_type
	ld	c,(hl)			; n/x/.. 㪢 ஢
	ld	a,"u"
	cp	c			; unsort ?
	call	nz,sorting_list		;     ஢
	call	show_pointer		; 뢥 㪠⥫
	jp	get_fire		;   "" ⮭





;---------------------------------------------------------------------
; ࠡ⪠ 誨  key-
;
; 室: hl=Y/X ⥪. न 誨
;---------------------------------------------------------------------
event_keybar:
	db	3Eh			; ld a,..
buttons_bits:
	db	0			;   ⮭
	ld	c,a
	ld	a,h
	cp	27			; Y न
	jr	z,event_footerline
	bit	0,c			; ࠢ ⮭ ?
	ret	nz			; 
	ld	a,h
	cp	31			; Y न
	jp	nz,event_comline	;   . ப
	ld	a,l			; X न
	push	af
	call	get_fire		;   ""
	pop	af
	cp	8
	ret	c;			; F1 㭪
	cp	16
	jp	c,user_menu		; F2 㭪
	cp	24
	jp	c,file_viewer		; F3 㭪
	cp	32
	ret	c;			; F4 㭪
	cp	40
	jp	c,copy			; F5 㭪
	cp	48
	jp	c,rename		; F6 㭪
	cp	56
	jp	c,make_folder		; F7 㭪
	cp	64
	jp	c,delete		; F8 㭪
	cp	72
	jp	nc,quit			; F10 㭪
	; F9 㭪
	jp	main_menu






;---------------------------------------------------------------------
; ࠡ⪠ 誨   ப
;---------------------------------------------------------------------
event_comline:
	cp	30			; Y . -ப
	ret	nz
	ld	a,(EvComMouse1+1)	; X 砫   -ப
	ld	h,a
	push	hl			; l=X न
	call	get_fire		;   ""
	pop	hl
	ld	a,l
	sub	h
	ret	c			; 誠  ப 
	ld	de,(YXpos+1)		; 砫   -ப
	ld	(CursorPos),de
	ld	iy,ComLineBuff		;   -ப
	jp	enter_to_comline
