;=====================================================================
; ᮢ ꥪ
; object ~Button~ ( 䮪)
; Input: HL=⥫ ꥪ
; Format table:
;       +0 -  ꥪ ~Claster check buttons"
;       +1 - Xo   ꥪ
;       +2 - Xi ࠢ  ꥪ
;       +3 - Y  ꥪ
;       +4 -  
;       +5 - ᪥- hot-
;       +6 - ⥪
;---------------------------------------------------------------------
; ଠ ⥫:
;	db	Button			;  ꥪ
;	dw	0205h			; Yo,Xo
;	db	" ~O~k ",0		;  ⮭
;	db	18h			; ᪥- hot-
;	db	cmOkey			;  
;	db	5			; ⥪
;=====================================================================
PutButton:
	push	iy
	inc	iy			; ன 祩 ࠧ ⠡
	ld	(iy+0),a		; +0  ꥪ
	ld	a,(hl)			; X pos
	inc	hl
	ld	c,a
	add	a,(ix+0)		; Pos X from begin screen
	ld	(iy+1),a		; +1 Xo left
	ld	a,(hl)			; Y pos
	inc	hl
	ld	b,a
	add	a,(ix+1)		; Pos Y from begin screen
	ld	(iy+3),a		;+3 Yo
	call	GetPutA
	ex	de,hl
	ld	a,(color_array+24)	; 梥 . 
	ld	c,a
	ld	b,0			; 稪 ਭ ⮭
	ld	(iy+5),b		; hot-key
	; ⠢  ⮭
	ld	a,(de)
PButLp1:inc	de
	cp	"&"
	jr	nz,PButN0
	; ⠢ hot-㪢
	ld	a,(de)
	ld	(hl),a			; hot-㪢  
	inc	hl
	inc	de
	push	bc
	ld	a,(color_array+25)	; 梥 hot-㪢 . 
	ld	b,a
	ld	a,c			; 梥 ⮭
	and	0F0h
	or	b
	ld	(hl),a			; ਡ
	pop	bc
	inc	hl
	inc	b
	ld	a,(de)
	inc	de
PButN0:	ld	(hl),a
	inc	hl
	ld	(hl),c
	inc	hl
	inc	b
	ld	a,(de)
	or	a
	jr	nz,PButLp1		;   
	inc	de
	ld	a,(de)			; ᪥- hot-
	inc	de
	ld	(iy+5),a		; hot-
	ld	a,(iy+1)		; Xi left
	add	a,b			; + ਭ ⮭
	ld	(iy+2),a		; Xi right
	ex	de,hl
	ld	a,(hl)			; ⥫ ꥪ
	inc	hl
	ld	(iy+4),a		;  
	ld	a,(hl)
	inc	hl
	ld	(iy+6),a		; ⥪
	ld	bc,7			; ࠧ ⠡ ꥪ "Button"
	add	iy,bc
	push	iy
	exx
	pop	hl
	pop	de			; de=iy
	and	a
	sbc	hl,de			; de=DialTab+5
	ld	a,l
	ld	(de),a			; ࠧ ⠡ ꥪ "Button"
	exx
	ret


;-------------------------------------------------
;   ꥪ "Button"
;-------------------------------------------------
ButtonI:ld	de,color_array+34	; 梥 Selected buttons
	ld	(set_dial_tmp_inv+1),de
	ld	e,(ix+2)		; Xo left
	ld	d,(ix+4)		; Y
	ld	a,(ix+3)		; Xi right
	sub	e
	ld	c,a
	call	SetDialInv		; 뤥 梥⮬
	ld	hl,color_array+26	; Selected title (ꥪ)
	ld	(set_dial_tmp_inv+1),hl	; . 祩
	ret




;=====================================================================
;
; ࠡ稪 ᮡ⨩ ꥪ⮢ "Button"
;
;=====================================================================
EvButton:
	ld	hl,what			;  ᮡ⨩
	ld	a,(hl)			;+0
	inc	hl
	cp	evMouseFr
	jr	z,EBmouse
	cp	evKeyboard
	jp	z,EBkeys
	cp	evCombKey
	ret	nz
	bit	7,(ix+1)		; sel or nosel
	ret	nz			; ꥪ 㦥 뤥
	ld	b,(hl)			;+1 what
	inc	hl
	ld	a,(hl)			;+2 what
	cp	56h			;  ࠢ
	jr	z,tb__
	push	ix
	ld	e,(ix+0)		; ࠧ ⠡ "Button"
	ld	d,0
	add	ix,de
	bit	7,(ix+0)
	pop	ix
	ret	z			;    ꥪ⮢
	cp	54h			;  
	jr	z,tb__
	ld	a,b
	and	00111111b		;  Ctrl, Alt
	ret	nz
	ld	a,(hl)			;+2 what
	cp	15+80h			; Tab  ᪥-+80h
	ret	nz
	; Shift+Tab
tb__:	xor	a
	ld	(_Push+1),a		; Push flag
	jp	SetButton		; select my

; ⨥ - 誠
EBmouse:ld	e,(hl)			;+1 X coord
	inc	hl
	ld	d,(hl)			;+2 Y coord
	ld	a,d
	cp	(ix+4)			; Y pos button
	jr	nz,get_fr		; if <> exit
	ld	a,e
	bit	7,(ix+2)
	jr	nz,$+6
	cp	(ix+2)			; Xo pos
	jr	c,get_fr		; <
	bit	7,(ix+3)
	jr	nz,get_fr
	cp	(ix+3)			; Xi pos
	jr	nc,get_fr		; >
	xor	a
	inc	a
	ld	(_Push+1),a		; Push flag
	bit	7,(ix+1)
	jr	nz,_Push
	jr	SetButton

; ⨥ - 筠 
EBkeys:	xor	a
	ld	(_Push+1),a		; Push flag
	ld	a,(hl)			;+1 what  
	bit	7,(ix+1)		; Sel or nosel
	jr	nz,EBkeyN
	cp	9			; Tab
	jr	z,SetButton		; if tab then set button
	jr	EBkeyN1
	;
EBkeyN:	cp	0Dh			; Enter
	jr	z,EBent
EBkeyN1:inc	hl
	ld	a,(hl)			;+2 what ᪥-
	cp	(ix+6)			; hot-㪢
	ret	nz
EBent:	ld	a,1
	ld	(_Push+1),a
SetButton:
	call	MoveObj			; Select Button
	call	ResDialInv		; Reset previos invert
	ld	ix,DialTab+5
	ld	de,color_array+34	; 梥 Selected buttons
	ld	(set_dial_tmp_inv+1),de
	ld	e,(ix+2)		; Xo
	ld	d,(ix+4)		; Y
	ld	a,(ix+3)		; Xi
	sub	e
	ld	c,a
	call	SetDialInv		; 뤥 ⮭ 梥⮬
	ld	de,color_array+26	; 梥 Selected title (ꥪ)
	ld	(set_dial_tmp_inv+1),de
_Push:	ld	a,0
	or	a
	jr	z,BTexit
	call	PushBut			; ᢥ 
	ld	hl,what
	ld	(hl),evCommand
	inc	hl
	ld	a,(ix+5)		;  
	ld	(hl),a
get_fr:	jp	get_fire
	;
; Button exit
BTexit:	ld	hl,what
	ld	(hl),evNothing
	ret
