;-----------------------------------------------------------
; ࠡ⪠ 誨  ASCII 
;
; 室: hl=Y/X ⥪. न 誨
;       d=  ⮭
;-----------------------------------------------------------
fview_mouse_ascii:
	ld	a,(viewer_mode)		; ० ࠡ 
	or	a
	jp	nz,get_fire		;  ०
	ld	bc,AB33F		; 窠 室
	push	bc
	ld	a,h
	or	a			; 0- ப
	jp	z,get_fire		;  . 
	cp	31			; key-
	jr	c,fv_ms_ascii		; ᮡ  
	; ᮡ key-
	bit	0,d			; ࠢ ⮭ ?
	jp	nz,get_fire		; 
	push	hl
	call	get_fire		;   ""
	pop	hl
	ld	a,l			; X न
	cp	8
	ret	c;			; F1 㭪
	cp	16
	jp	c,AB5C8			; F2 㭪 Wrap/UnWrap
	cp	24
	ret	c;			; F3 㭪
	pop	bc			; .  ⥪ ( 㭪 F4)
	cp	32
	jp	c,ABB1C			; F4 㭪  HEX-०
	push	bc			;  室  ⥪
	cp	40
	ret	c;			; F5 㭪
	cp	48
	ret	c;			; F6 㭪
	cp	56
	ret	c;			; F7 㭪
	cp	64
	jp	c,change_code_page	; F8 㭪  . ࠭
	cp	72
	ret	c;			; F9 㭪
	; F10 㭪
	pop	bc			; .  ⥪
	ret				; F10 㭪


;  
; 室: hl=Y/X . 誨 (Y=1..30, X=0..79)
;       d=  ⮭
fv_ms_ascii:
	bit	0,d			; ࠢ ⮭ ?
	jr	nz,fv_ms_ascii_right	; 
	ld	a,h			; X न
	cp	16			; 砫   
	jp	c,fv_ms_ascii1
	;  ப 
	call	AB987
	halt
	call	get_mouse_info
	and	3
	jr	nz,$-9			; ⮭ 
	ld	a,evNothing
	ld	(what),a		; ᯨ᮪ ᮡ⨩
	ret
	;  ப 
fv_ms_ascii1:
	call	AB81D
	halt
	call	get_mouse_info
	and	3
	jr	nz,$-9			; ⮭ 
	ld	a,evNothing
	ld	(what),a		; ᯨ᮪ ᮡ⨩
	ret

; ࠢ ⮭
fv_ms_ascii_right:
	ld	a,l			; Y न
	cp	40			; 砫 ࠢ  
	jr	c,fv_ms_ascii_right1
	;  ࠢ
	call	AB610
	halt
	call	get_mouse_info
	and	3
	jr	nz,$-9			; ⮭ 
	ld	a,evNothing
	ld	(what),a		; ᯨ᮪ ᮡ⨩
	ret
	;  
fv_ms_ascii_right1:
	call	AB5FE
	halt
	call	get_mouse_info
	and	3
	jr	nz,$-9			; ⮭ 
	ld	a,evNothing
	ld	(what),a		; ᯨ᮪ ᮡ⨩
	ret







;-----------------------------------------------------------
; ࠡ⪠ 誨  HEX 
;
; 室: hl=Y/X ⥪. न 誨.
;       d=  ⮭
;-----------------------------------------------------------
fview_mouse_hex:
	ld	a,(viewer_mode)		; ० ࠡ 
	or	a
	jp	nz,get_fire		;  ०
	ld	bc,ABB4A		; 窠 室
	push	bc
	ld	a,h
	or	a			; 0- ப
	jp	z,get_fire		;  . 
	cp	31			; key-
	jr	c,fv_ms_hex		; ᮡ  
	; ᮡ key-
	bit	0,d			; ࠢ ⮭ ?
	jp	nz,get_fire		; 
	push	hl
	call	get_fire		;   ""
	pop	hl
	ld	a,l			; X न
	cp	8
	ret	c;			; F1 㭪
	cp	16
	ret	c;			; F2 㭪
	cp	24
	ret	c;			; F3 㭪
	pop	bc			; .  ⥪ ( 㭪 F4)
	cp	32
	jp	c,AB317			; F4 㭪  ASCII-०
	push	bc			;  室  ⥪
	cp	40
	jp	c,ABDF3			; F5 㭪 Goto...
	cp	48
	ret	c;			; F6 㭪
	cp	56
	ret	c;			; F7 㭪
	cp	64
	jp	c,change_code_page1	; F8 㭪  . ࠭
	cp	72
	ret	c;			; F9 㭪
	; F10 㭪
	pop	bc			; .  ⥪
	ret				; F10 㭪


;  
; 室: hl=Y/X . 誨 (Y=1..30, X=0..79)
;       d=  ⮭
fv_ms_hex:
	bit	0,d			; ࠢ ⮭ ?
	ret	nz			; 
	ld	a,h			; X न
	cp	1
	jr	nz,$+9
	ld	a,l			; X न
	cp	9			;     ?
	jp	c,ABDF3			; , Goto...
	ld	a,h
	cp	16			; 砫   
	jp	c,fv_ms_hex1
	;  ப 
	call	ABCDB
	halt
	call	get_mouse_info
	and	3
	jr	nz,$-9			; ⮭ 
	ld	a,evNothing
	ld	(what),a		; ᯨ᮪ ᮡ⨩
	ret
	;  ப 
fv_ms_hex1:
	call	ABC9A
	halt
	call	get_mouse_info
	and	3
	jr	nz,$-9			; ⮭ 
	ld	a,evNothing
	ld	(what),a		; ᯨ᮪ ᮡ⨩
	ret



;-----------------------------------------------------------
; ࠡ⪠ 誨     Goto...
;
; 室: hl=Y/X ⥪. न 誨.
;       a=  ⮭
;-----------------------------------------------------------
fview_mouse_goto:
	ld	a,(viewer_mode)		; ० ࠡ 
	or	a
	jp	nz,get_fire		;  ०
	ld	bc,ABE29		; 窠 室
	push	bc
	ld	a,h
	dec	a			; 1- ப
	jr	nz,$+6
	ld	a,l			; X न
	cp	9
	ret	c			;    
	pop	bc			; .  ⥪
	call	get_fire		;  ०
	jp	ABF5C			; Esc
