;///////////////////////////////////////////////////////////
;
;  믮 㭪⮢ pull-
;
;///////////////////////////////////////////////////////////
pull_commands:
	ld	hl,what			;  ᮡ⨩
	ld	a,(hl)
	cp	evCommand		; ᮡ⨥ "" ?
	ret	nz			; 
	inc	hl
	ld	a,(hl)			;+1   (㭪)
	ld	c,a			; . 
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,pull_array		; ᯨ᮪ ࠡ稪
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	a,c			; .  
	jp	(hl)			; a=室. ࠬ


; ᯨ᮪ ࠡ稪 pull-
pull_array:
	; Left
	dw	left_right		; brief-ଠ
	dw	left_right		; medium-ଠ
	dw	left_right		; full-ଠ
	dw	left_info		; info-ଠ
	dw	left_qview		; qview-ଠ
	dw	left_right		; sort "Name"
	dw	left_right		; sort "Ext"
	dw	left_right		; sort "Date"
	dw	left_right		; sort "Size"
	dw	left_right		; "Unsort"
	dw	pull_empty		;LFilter
	dw	select_left_drive	;  롮 ᪮
	; Files
	dw	pull_empty		;Help
	dw	user_menu		; 맮  짮⥫
	dw	pull_empty		;View
	dw	pull_empty		;Edit
	dw	copy			; Copy
	dw	rename			; Rename
	dw	make_folder		; Make folder
	dw	delete			; Delete
	dw	pull_empty;set_attrib2	; 뢮  ਡ⮢ 䠩/
	dw	pull_empty		;SelGroup
	dw	pull_empty		;USelGroup
	dw	quit			; 室  
	; Commands
	dw	pull_empty		;Find
	dw	pull_empty		;Volume
	dw	swap_panels		;  
	dw	hidden_panels		; / 
	dw	pull_empty		;Create TRD-image
	dw	pull_empty		;TRD-image -> Disk
	dw	pull_empty		;Disk -> TRD-image
	; Options
	dw	set_interface		;  ன 䥩
	dw	set_confirm		;  ன ⢥ত
	dw	setup_colors		; ன 梥⮢ 
	dw	pull_empty		;Highlight
	dw	pull_empty		;ViewSet
	dw	pull_empty		;EditSet
	dw	write_ini_file		;  ini-䠩
	; Right
	dw	left_right		; brief-ଠ
	dw	left_right		; medium-ଠ
	dw	left_right		; full-ଠ
	dw	right_info		; info-ଠ
	dw	right_qview		; qview-ଠ
	dw	left_right		; sort "Name"
	dw	left_right		; sort "Ext"
	dw	left_right		; sort "Date"
	dw	left_right		; sort "Size"
	dw	left_right		; "Unsort"
	dw	pull_empty		;RFilter
	dw	select_right_drive	;  롮 ᪮

; 誠
pull_empty:
	ret





;///////////////////////////////////////////////////////////
; 㭪  Left/Right ( "Filter...")
; 室: a= pull-㭪
;///////////////////////////////////////////////////////////
left_right:
	ld	(punct_left_right),a
	ld	hl,show_pointer		; 窠 室
	push	hl
	cp	cmLUnsort+1
	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
	jr	c,punct_left
; Right-㭪 
	rlca
	jr	c,pars_left_right	; . ࠢ
lft_right1:
	call	change_panel
	call	pars_left_right
	jp	change_panel

; Left-㭪 
punct_left:
	rlca
	jr	c,lft_right1		; . ࠢ
	;
pars_left_right:
	db	3Eh			; ld a,..
punct_left_right:
	db	0			;  pull-㭪
	; ଠ ᯨ᪠
	cp	cmLBrief
	jp	z,set_format_brief
	cp	cmRBrief
	jp	z,set_format_brief
	cp	cmLMed
	jp	z,set_format_medium
	cp	cmRMed
	jp	z,set_format_medium
	cp	cmLFull
	jp	z,set_format_full
	cp	cmRFull
	jp	z,set_format_full
	; ஢ ᯨ᪠
	ld	c,"n"			; name
	cp	cmLName
	jr	z,punct_sort
	cp	cmRName
	jr	z,punct_sort
	ld	c,"x"			; ext
	cp	cmLExt
	jr	z,punct_sort
	cp	cmRExt
	jr	z,punct_sort
	ld	c,"d"			; date
	cp	cmLDate
	jr	z,punct_sort
	cp	cmRDate
	jr	z,punct_sort
	ld	c,"s"			; size
	cp	cmLSize
	jr	z,punct_sort
	cp	cmRSize
	jr	z,punct_sort
	ld	c,"u"			; unsorted
	cp	cmLUnsort
	jr	z,punct_sort
	cp	cmRUnsort
	jr	z,punct_sort
	ret



;///////////////////////////////////////////////////////////
;  ஢ ᯨ᪠
;///////////////////////////////////////////////////////////
punct_sort:
	jp	sorting_list




;///////////////////////////////////////////////////////////
; 맮 info-
;///////////////////////////////////////////////////////////
; Left-㭪
;left_info:
;	ld	hl,show_pointer
;	push	hl
;	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
;	rlca
;	jp	c,alt_info_panel	; . ࠢ ( .  ->  . )
;	jp	set_info_actpanel	;  .  ->  . 
;
;
; Right-㭪
;right_info:
;	ld	hl,show_pointer
;	push	hl
;	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
;	rlca
;	jp	nc,alt_info_panel	; .  ( .  ->  . )
;	jp	set_info_actpanel	;  .  ->  . 
left_info:
	ld	hl,show_pointer
	push	hl
	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
	rlca
	jp	c,alt_info_panel	; . ࠢ
lft_info1:
	call	change_panel
	call	alt_info_panel
	jp	change_panel

; Right-㭪
right_info:
	ld	hl,show_pointer
	push	hl
	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
	rlca
	jp	nc,alt_info_panel	; . 
	jr	lft_info1



;///////////////////////////////////////////////////////////
; 맮 qview-
;///////////////////////////////////////////////////////////
; Left-㭪
left_qview:
	ld	hl,show_pointer
	push	hl
	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
	rlca
	jp	c,alt_qview_panel	; . ࠢ
lft_qview1:
	call	change_panel
	call	alt_qview_panel
	jp	change_panel


; Right-㭪
right_qview:
	ld	hl,show_pointer
	push	hl
	ld	a,(cur_panel)		; 0/#80 /ࠢ . 
	rlca
	jp	nc,alt_qview_panel	; . 
	jr	lft_qview1
