;/////////////////////////////////////////////////////////////////////
; 뢮  .  ->  .   (뢠  䠩)
; <ਣୠ >
;/////////////////////////////////////////////////////////////////////
alt_info_panel:
	call	test_show_panels	;   ० . 
	ret	z			; 몫.
	;   qview-ଠ  . 
	ld	a,(format_mode)		; ଠ . 
	and	form_info
	jr	nz,set_norm_actpanel2	; 뢥 . ⨢ 
	ld	hl,info1_		; ਣ . 
	ld	a,(hl)
	or	a
	jr	nz,set_norm_noactpanel2	; 뢥 . ᨢ 
	jr	set_info_noactpanel	; info-  .  (. )



;--------------------------------------------------
; 뢥 ଠ쭮 . 
;--------------------------------------------------
set_norm_actpanel2:
	ld	hl,info_		; ਣ . 
	ld	(hl),0			; . ਣ
	inc	hl
	ld	a,(hl)			; 祩 form_under_info
	ld	(format_mode),a		; ଠ . 
	jp	A20FC			; 뢥 

;--------------------------------------------------
; 뢥 ଠ쭮 . 
;--------------------------------------------------
set_norm_noactpanel2:
	call	change_panel
	call	set_norm_actpanel2
	jp	change_panel



;----------------------------------------------------
; 뢥 info-  .  (. )
; (뢠  )
;----------------------------------------------------
set_info_actpanel:
	;  묨 -⥫ + .  ⨯
	call	change_panel
	call	get_info_data
	call	change_panel
set_info_actpanel1:
	ld	de,format_mode		; ଠ . 
	ld	a,(de)
	bit	3,a			; info
	ret	nz			;  ࠡ. ୮
	bit	4,a			; qview
	jr	z,$+5
	ld	a,(form_under_qview)	; ଠ  qview-
	ld	hl,info_		; ਣ . 
	ld	(hl),1			; . ਣ
	inc	hl
	ld	(hl),a			; form_under_info
	and	form_trd		;  6-  ᯥ-ଠ
	or	form_info
	ld	(de),a			; . info-ଠ
	xor	a
	ld	(qview_),a		; . qview-ਣ
	ld	(enter_done3+1),a	; . 䫠  info-
	ret

;----------------------------------------------------
; 뢥 qview-  .  (. )
;----------------------------------------------------
set_info_noactpanel:
	;  묨 -⥫ + .  ⨯
	call	get_info_data
	xor	a
	ld	(D48B1),a		; .  ⫠
	call	change_panel
	call	set_info_actpanel1	; 뢮 . 
	call	draw_half_frame		;  
	call	prn_up_path		; 뢥 . ⥫
	call	change_panel
	ld	a,true
	ld	(D48B1),a		; .  ⫠
	ret




;-----------------------------------------------------------
;  -⥫ 묨 ᪠ (. )
;-----------------------------------------------------------
get_info_data:
	ld	hl,win_info_panel	; ⥫ "Calculating disk space..."
	call	WinSimple		;  
	;
	; ந ப ⥪. 
	call	info_get_date
	;
	;   稥 / CMOS
	ld	c,0F5h
	rst	08h
	ld	hl,cmos_yes		; "Yes"
	jr	nc,$+5
	ld	hl,cmos_no		; " No"
	ld	b,3			;  ப
	ld	ix,info_cmos_string
	call	A0E90			; ᪮஢ ப
	;
	;  BIOS
	ld	hl,work_buffer		; ६. 
	ld	c,0EFh			;   ᨨ   
	rst	08h
	push	bc
	push	de
	xor	a
	ld	l,d
	ld	h,a
	ld	ix,info_bios_version	; 
	exx
	ld	l,a			; . ࠧ
	ld	h,a
	exx
	ld	bc,0120h		;  . ஡
	ld	iy,tmp1__
	res	7,(iy+0)
	call	dec2
	pop	hl
	ld	a,l
	ld	(ix+0),"."
	inc	ix
	call	dec8
	pop	hl
	ld	h,0
	ld	(ix+0),"."
	inc	ix
	call	dec16
	;
	; Board ID
	ld	bc,01EDh
	rst	08h
	ld	ix,info_board_id	; 
	push	de
	push	hl
	ld	a,b
	call	hex8			; hex
	ld	(ix+0),"-"
	inc	ix
	ld	a,c
	call	hex8			; hex
	ld	(ix+0),"-"
	inc	ix
	pop	hl			; . ࠧ
	exx
	ld	hl,0			; . ࠧ
	exx
	ld	bc,0130h		;  . ﬨ
	ld	iy,tmp1__
	res	7,(iy+0)
	call	dec5			; 16-bit . 뢮 ( . ﬨ)
	pop	hl
	call	hex16			; hex
	;
	; 騩 
	ld	a,(disk)
	add	a,"A"
	ld	(info_hdd+14),a		; 祩 㪢 ᪠
	ld	(info_cdrom+15),a
	ld	(info_fdd+16),a
	ld	(info_ram+13),a
	;  BPB ᪠
	ld	a,(disk)		;  ᪠
	ld	c,1			; open device
	rst	18h
	jr	c,get_inf_data_err
	ld	a,(disk)
	ld	de,work_buffer		; 
	ld	c,4			; get BPB
	rst	18h
	push	af
	ld	a,(disk)		;  ᪠
	ld	c,2			; close device
	rst	18h
	pop	af
	jr	c,get_inf_data_err
	;  ଠ ⥫
	ld	a,(work_buffer+21)
	ld	(media_byte),a
get_inf_data_err:
	; ਩  . ᪠
	ld	ix,info_serial		; xxxx-xxxx
	ld	hl,(work_buffer+41)	; .
	call	hex16
	ld	(ix+0),"-"
	inc	ix
	ld	hl,(work_buffer+39)	; .
	call	hex16
	;
	; ⪠ ᪠
	ld	a,(disk)		;  ᪠
	cp	2			;  "C:" ?
	jr	nc,get_inf_data1	; ⪠  BPB
	; floppy, ⪠ -  䠩
	ld	c,1			; . 
	rst	10h
	ld	hl,scan_mask		; "*.*"  ᪠ ⪨ ⮬
	ld	de,work_buffer+127;255
	ld	a,8			; ਡ ⪨ ⮬
	ld	bc,0019h		; F_FIRST, ଠ "FilenameExt"
	rst	10h
	jr	c,get_inf_data1		; ⪨ 
	ld	hl,work_buffer+127+43	;+255+43 㤠 ( ⪨)
	jr	$+5
get_inf_data1:
	ld	hl,work_buffer+53	; 㤠 ( ⪨)
	ld	de,info_volume+10	; 㤠 ( ப)
	ld	ix,info_volume
	call	copy_volume		; ᪮. 
	;
	; ꥬ ᪠
	ld	a,(disk)		;  ᪠
	ld	c,3			;   ᪥
	rst	10h
	jr	nc,get_inf_data_ok
	xor	a
	ld	l,a
	ld	h,a
	ld	e,a
	ld	d,a
	ld	c,a
	ld	b,a
	inc	a
get_inf_data_ok:
	; a=ࠧ   ᥪ
	; bc=ࠧ ᥪ  
	; hl=饥 - ஢
	; de=᢮. ஢
	push	de
	push	hl
	ld	hl,0
	add	hl,bc			; ᫨ ࠧ 
	dec	a
	jr	nz,$-2
	ex	de,hl			; de=ࠧ 
	pop	bc			; .- ஢
	call	mul_bcde		; bc*de=hlbc 騩 ꥬ ᪠
	push	hl
	exx
	pop	hl			; .ࠧ
	exx
	ld	l,c			; .ࠧ
	ld	h,b
	push	de
	ld	ix,info_total_bytes	; 0,000,000,000
	call	decimal32
	; ᢮ 
	pop	de			; ࠧ 
	pop	bc			; ᢮. ஢
	call	mul_bcde		; bc*de=hlbc ᢮. 
	push	hl
	exx
	pop	hl			; .ࠧ
	exx
	ld	l,c			; .ࠧ
	ld	h,b
	ld	ix,info_free_bytes	; 0,000,000,000
	call	decimal32
	; ᥣ 
	ld	c,3Ch			; ଠ  
	rst	10h
	push	bc
	ld	ix,info_total_memory	; 0,000,000
	call	conv_kbytes		; kbytes -> bytes  뢮  
	pop	hl
	;  
	ld	ix,info_free_memory	; 0,000,000
	call	conv_kbytes		; kbytes -> bytes  뢮  
	;
	; 뢮 ப ᪠ . 
	db	3Eh			; ld a,..
media_byte:
	db	0			;  ଠ  BPB
	ld	hl,info_hdd		; fixed disk
	cp	0F8h
	jr	z,get_inf_data2
	ld	hl,info_fdd		; removable disk
	cp	0F0h			; 1.44Mb
	jr	z,get_inf_data3
	cp	0F9h			; 720kB
	jr	z,get_inf_data3
	ld	hl,info_ram		; ram-disk
	cp	0FAh
	jr	z,$+5
	ld	hl,info_cdrom		; cd-rom
get_inf_data2:
	ld	de,info_type_device	; 㤠
	ld	bc,19			;  ப
	ldir
	;   ᯥ-ଠ
	ld	a,(format_mode)
	and	form_trd
	call	nz,get_spec_info	;  ᯥ-⥫
	;   
	ld	a,1
	rst	20h
	;   "Calculating disk space..."
	jp	CloseWinSimple

get_inf_data3:
	ld	a,(disk)		;  ᪠
	cp	2			;  "C:" ?
	jr	c,$+5
	ld	hl,info_ram		; ram-
	jr	get_inf_data2



; ஢    ⪨ ᪠.
; 室: hl=㤠 ( ⪨)
;       de=㤠 ( ப ⪨)
;       ix=砫 ப ⪨
copy_volume:
	ld	bc,11			;  ⪨
	ld	a,(hl)
	cp	" "+1
	jr	nc,$+10
	dec	hl
	dec	c
	jr	nz,$-7
	ld	a,11
	jr	$+7
	;
	ld	a,11
	sub	c
	lddr
	ld	b,a
	or	a			;  ⪨ 11 ᨬ. ?
	call	nz,spaces		;  . ஡
	ret


; ॢ ᫠ ࠭    뢮 ᫠  
; 室: hl=᫮ ࠭
;       ix=
conv_kbytes:
	add	hl,hl			; ࠧ   kB
	add	hl,hl			; x4
	add	hl,hl			; x8
	add	hl,hl			; x16
	; ॢ  
	ex	de,hl
	ld	bc,1024			; 1 
	call	mul_bcde		; bc*de=hlbc ᥣ 
	push	hl
	exx
	pop	hl			; .ࠧ
	exx
	ld	l,c			; .ࠧ
	ld	h,b
	ld	iy,tmp2__
	res	7,(iy+0)
	jp	decimal24




;-------------------------------------------------
; ந  info-⥫ ப ⥪. 
;-------------------------------------------------
info_get_date:
	ld	c,21h			; . 
	rst	10h
	push	ix			; 
	push	de			; /
	ld	ix,info_date_string	; 
	ld	bc,0120h		;  . ஡
	ld	iy,tmp1__
	res	7,(iy+0)
	ld	l,d			; 
	ld	h,0
	call	dec2			; 0..99 ᫮
	pop	hl
	ld	c,l			; 
	ld	h,0
	add	hl,hl
	ld	de,info_array_months-2
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	de,info_date_string+3	; 
	; ᪮.  
info_get_date_loop:
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	or	a
	jr	nz,info_get_date_loop
	dec	de
	ld	a," "
	ld	(de),a
	inc	de
	push	de
	pop	ix			; 
	pop	hl			; 
	push	bc
	ld	b,0			;  ⠢ . ᨬ
	ld	iy,tmp1__
	res	7,(iy+0)
	call	dec4			; 0..9999 ᫮
	ld	(ix+0),0		;  ⥫
	pop	bc			; c=
	; ந 祩 ⥫
	ld	a,c
	ld	c,7+8			;   ப
	ld	b,0Ch
	dec	a			; a=1
	jr	z,info_get_date1
	inc	c
	dec	a			; a=2
	jr	z,info_get_date1
	ld	c,5+8
	inc	b			; b=0Dh
	dec	a			; a=3
	jr	z,info_get_date1
	dec	a			; a=4
	jr	z,info_get_date1
	inc	b			; b=0Eh
	ld	c,3+8
	dec	a			; a=5
	jr	z,info_get_date1
	inc	c
	dec	a			; a=6
	jr	z,info_get_date1
	dec	a			; a=7
	jr	z,info_get_date1
	dec	b			; b=0Dh
	ld	c,6+8
	dec	a			; a=8
	jr	z,info_get_date1
	dec	b
	dec	b			; b=0Bh
	ld	c,9+8
	dec	a			; a=9
	jr	z,info_get_date1
	inc	b			; b=0Ch
	ld	c,7+8
	dec	a			; a=10
	jr	z,info_get_date1
	inc	c
info_get_date1:
	ld	hl,info_date_string-1
	ld	(hl),b			; X . ப
	ld	hl,info_date
	ld	(hl),c			;  ப
	ret


info_array_months:
	dw	inf_jan
	dw	inf_feb
	dw	inf_mar
	dw	inf_apr
	dw	inf_may
	dw	inf_jun
	dw	inf_jul
	dw	inf_aug
	dw	inf_sep
	dw	inf_oct
	dw	inf_nov
	dw	inf_dec

inf_jan:db	"January",0
inf_feb:db	"February",0
inf_mar:db	"March",0
inf_apr:db	"April",0
inf_may:db	"May",0
inf_jun:db	"June",0
inf_jul:db	"July",0
inf_aug:db	"August",0
inf_sep:db	"September",0
inf_oct:db	"October",0
inf_nov:db	"November",0
inf_dec:db	"December",0




;-------------------------------------------------
;  ᯥ-⥫ 묨 ᯥ-
; 室: .  묨 ᯥ-
;-------------------------------------------------
get_spec_info:
	;  ࠧ
	ld	a,(image_type);		;  ⨯
	ld	c,a
	add	a,a			;1+1=2
	add	a,c			;2+1=3
	ld	c,a
	ld	b,0
	ld	hl,list_image_types	; ᯨ᮪ ⨯ ࠧ
	add	hl,bc			; 㤠
	ld	de,img_type		; 㤠
	ld	bc,3
	ldir
	; ⪠ ᪠
	ld	hl,test_vol+10;		; 㤠 ( ⪨)
	ld	de,trd_vol+10		; 㤠 ( ப)
	ld	ix,trd_vol		; 砫 ப ⪨
	call	copy_volume		; ᪮. 
	;  ᪠
	ld	a,(spec_type);		;  ⨯
	ld	c,a
	add	a,a			;1+1=2
	add	a,a			;2+2=4
	add	a,c			;4+1=5
	ld	c,a
	ld	b,0
	ld	hl,list_disk_types	; ᯨ᮪ ⨯ ᯥ-᪠
	add	hl,bc			; 㤠
	ld	de,trd_type		; 㤠
	ld	bc,5
	ldir
	;   
	ld	a,0;			; 䫠   0=, 1=
	or	a
	ld	hl,"a "			; " absent"
	ld	a,"b"
	jr	z,$+7
	ld	hl,"rp"			; "present"
	ld	a,"e"
	ld	(trd_protect),hl	; ९ 
	ld	(trd_protect+2),a	;  ᨬ
	; ᥣ 䠩
	ld	a,255;			; ᫮
	ld	ix,trd_files		; 
	call	dec9			; 뢮 ᥫ 0..999  . ஡
	;  䠩
	ld	a,0;			; ᫮
	ld	ix,trd_delfiles		; 
	call	dec9
	;  SCL-  㫨
	ld	a,(image_type)		; ⨯ 
	or	a
	jr	nz,get_spec_inf_scl	; scl, 㫨
	; ࢠ ᢮ ஦
	ld	de,1;			; ᫮
	ld	ix,ffree_trk		; 
	call	dec16s			; 뢮 ᥫ 0..65535  . ஡
	;  ᢮ ᥪ
	ld	de,0;			; ᫮
	ld	ix,ffree_sec		; 
	call	dec16s
	;  ᥪ஢
	ld	de,2544;		; ᫮
	ld	ix,free_sec		; 
	jp	dec16s


; 㫨 3 祭
get_spec_inf_scl:
	ld	bc,5
	ld	a,c
	ld	hl,spec_null		; 㤠
	ld	de,ffree_trk		;  "First free trk"
	ldir
	ld	hl,spec_null
	ld	de,ffree_sec		;  "First free sec"
	ld	c,a
	ldir
	ld	hl,spec_null
	ld	de,free_sec		;  "Number of free sectors"
	ld	c,a
	ldir
	ret

spec_null:
	db	"    0"			; 﫪


;  ᯥ- (0=TRD, 1=SCL)
image_type:
	db	0			; 

;  ᯥ-᪠ (0=2S/DD, 1=2S/SD, 2=1S/DD, 3=1S/SD, 4=??/??)
spec_type:
	db	0			; 


; ᯨ᮪ ⨯ 
list_image_types:
	db	"TRD"			; 0
	db	"SCL"			; 1

; ᯨ᮪ ⨯ ᯥ-᪮
list_disk_types:
	db	"2S/DD"			; 0
	db	"2S/SD"			; 1
	db	"1S/DD"			; 2
	db	"1S/SD"			; 3
	db	"??/??"			; 4





; ⮢ ப. 
test_vol:;
	db	"ADVENT#10/2";
