;-----------------------------------------------------------
; ᮢ ꥪ ~Pallete Box~
; Input: HL-label
; Format mouse table:
;       +0 - Object ~Pallete Box"
;       +1 - Xo position object
;       +2 - Xi position object
;       +3 - Yo position object
;       +4 - Yi position object
;       +5 - Xi position name
;       +6 - ᫮ 梥.   X
;       +7 - ᫮ 梥.   Y
;       +8 - ⥪.
;       +9 - hot-㪢
;      +10 - ⥪
;-----------------------------------------------------------
;	db	PalleteBox
;	dw	022Bh,0404h		; Yo,Xo,lenY,lenX
;	db	"&Foreground",0
;	db	0			; ⥪
;	db	0Fh			; ᪠
;	dw	ColPal			;  . 梥
;-----------------------------------------------------------
;
PPallete:
        LD      (IY+1),A
        LD      A,(HL)			; X pos
        INC     HL
        LD      C,A
        LD      (IX+4),A		; Save X pos
        ADD     A,(IX+0)		; Pos X from begin window
        LD      (IY+2),A                ;+1 Xo
        LD      A,(HL)			; Y pos
        INC     HL
        LD      B,A
        LD      (IX+5),A		; Save Y pos
        ADD     A,(IX+1)		; Pos Y from begin window
        LD      (IY+4),A                ;+3 Yo
        CALL    GetPutA
        LD      A,(HL)			; len X
        INC     HL
        LD      (IY+7),A		; ᫮ 梥.   X
        LD      C,A
        ADD     A,A			;1+1=2
        ADD     A,C			;2+1=3
        LD      (IX+6),A
        LD      B,A
        ADD     A,2
        ADD     A,(IY+2)
        LD      (IY+3),A		; Xi pos
        LD      A,(HL)			; len Y
        INC     HL
        LD      (IY+8),A		; ᫮ 梥.   Y
        ADD     A,A
        ADD     A,2			; Yi pos
        ADD     A,(IY+4)
        LD      (IY+5),A
        LD      A,""
        LD      (DE),A
        INC     DE
        INC     DE
        LD      A," "			; . ஡ 
        LD      (DE),A
        INC     DE
        INC     DE
        DEC     B
        LD      A,(color_array+24)	; 梥 . 
        LD      C,A
        LD      A,(HL)
PltBox0:INC     HL
        CP      "&"
        JR      NZ,PltBox1
        LD      A,(HL)
        LD      (DE),A			; hot-㪢  
        INC     HL
        INC     DE
	push	bc
	ld	a,(color_array+25)	; 梥 hot-㪢 . 
	ld	b,a
	ld	a,c			; 梥 ⮭
	and	0F0h
	or	b
	ld	(de),a			; ਡ
	pop	bc
	inc	de
        DEC     B
        LD      A,(HL)
        INC     HL
PltBox1:LD      (DE),A
        INC     DE
        INC     DE
        DEC     B
        LD      A,(HL)
        OR      A
        JR      NZ,PltBox0
        INC     HL
	ld	a,(hl)
	inc	hl
	ld	(iy+10),a		; hot-㪢
        LD      A," "			; . ஡ 
        LD      (DE),A
        INC     DE
        INC     DE
        DEC     B
        LD      A,(IX+6)
        SUB     B
        ADD     A,(IY+2)
	inc	a
        LD      (IY+6),A		; Xi . 
        LD      A,B
        OR      A
        JR      Z,PltBox2
        LD      A,""
        LD      (DE),A
        INC     DE
        INC     DE
        DJNZ    $-3
PltBox2:LD      A,""
        LD      (DE),A
        INC     (IX+5)
        LD      A,(HL)			; ⥪
        INC     HL
        LD      (IY+11),A
        LD      A,(HL)
        INC     HL
        LD      (IY+9),A		; ᪠ 梥⮢  ⥫
        LD      A,(HL)
        INC     HL
        LD      (IY+12),A		;  砫쭮 梥
        LD      A,(HL)
        INC     HL
        LD      (IY+13),A
        PUSH    HL
        LD      A,(color_array+24)	; 梥 . 
        AND     0F0h
        LD      (IX+6),A		; 砫 梥
        LD      B,(IY+8)
	; 横 뢮 梥. 
PltBox3:PUSH    BC
        LD      C,(IX+4)		; pos element
        LD      B,(IX+5)
        CALL    GetPutA
        EX      DE,HL
        LD      (HL),""		; 砫 ᨬ 梥. 
        INC     HL
        INC     HL
        LD      B,(IY+7)		;  梥.   ᨬ
        LD      A,(IX+6)		; 砫 梥
        LD      C,""			; ᨬ  梥. 
PltBox4:LD      (HL),C
        INC     HL
        LD      (HL),A
        INC     HL
        LD      (HL),C
        INC     HL
        LD      (HL),A
        INC     HL
        LD      (HL),C
        INC     HL
        LD      (HL),A
        INC     HL
        INC     A
        DJNZ    PltBox4
        LD      (HL),""		;  ᨬ 梥. 
        EX      DE,HL
        INC     (IX+5)			; ++Y . 
        LD      C,(IX+4)		; bc=Y/X . 梥. 
        LD      B,(IX+5)
        CALL    GetPutA
        EX      DE,HL
        LD      (HL),""		; 砫 ᨬ 梥. 
        INC     HL
        INC     HL
        LD      B,(IY+7)
        LD      A,(IX+6)
        LD      C,""			; ᨬ  梥. 
PltBox5:LD      (HL),C
        INC     HL
        LD      (HL),A
        INC     HL
        LD      (HL),C
        INC     HL
        LD      (HL),A
        INC     HL
        LD      (HL),C
        INC     HL
        LD      (HL),A
        INC     HL
        INC     A
        DJNZ    PltBox5
        LD      (HL),""		;  ᨬ 梥. 
        EX      DE,HL
        INC     (IX+5)
        LD      A,(IY+7)
        ADD     A,(IX+6)
        LD      (IX+6),A
        POP     BC
        DJNZ    PltBox3
	;  梥.  뢥
        LD      C,(IX+4)		; pos element
        LD      B,(IX+5)
        CALL    GetPutA
        EX      DE,HL
        LD      (HL),""
        INC     HL
        INC     HL
        LD      A,(IY+3)
        SUB     (IY+2)
        SUB     2
        LD      B,A
        LD      A,""
        LD      (HL),A
        INC     HL
        INC     HL
        DJNZ    $-3
        LD      (HL),""
        LD      L,(IY+12)		;  砫쭮 梥
        LD      H,(IY+13)
        LD      A,(HL)			; 梥
        AND     (IY+9)
        BIT     7,(IY+9)
        JR      Z,$+6
        RRCA
        RRCA
        RRCA
        RRCA
        LD      B,-1
        INC     B
        SUB     (IY+7)
        JR      NC,$-4
        ADD     A,(IY+7)
        LD      C,A
        ADD     A,A			;1+1=2
        ADD     A,C			;2+1=3  ਧ. 蠣
	inc	a
        LD      C,A
        LD      A,B
        ADD     A,A			;1+1=2  . 蠣
        INC     A
        LD      B,A
        LD      A,(IY+2)
        SUB     (IX+0)
        INC     A
        ADD     A,C
        LD      C,A
        LD      A,(IY+4)
        SUB     (IX+1)
        INC     A
        ADD     A,B
        LD      B,A
        CALL    GetPutA
        LD      A,"*"
        LD      (DE),A
        INC     DE
        LD      A,(color_array+24)	; 梥 . 
        LD      (DE),A
	POP     HL
        LD      BC,14
        LD      (IY+0),C
        ADD     IY,BC
        RET





;-------------------------------------------------
; Object ~Pallette Resident 1 or 2~
; Format mouse table:
;       +0 - Object ~Pallette Resident~
;-------------------------------------------------
PResid2:EX      AF,AF'
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        INC     HL
        LD      (AdrCol+1),DE		; ⥪.   ᨢ 梥⮢
        LD      A,(page_dial_screen)	; page buffer
        OUT     (PAGE_3),A
        EX      AF,AF'
        JR      PResid1

;-------------------------------------------------
; Object ~Pallette Resident 1 or 2~
; Format mouse table:
;       +0 - Object ~Pallette Resident~
;-------------------------------------------------
PResid1:LD      (IY+0),2		;  ⠡ "Pallette Resident" ?
        INC     IY
        LD      (IY+0),A                ;+0  ꥪ ~Pallette Resident 1  2~
        INC     IY
        RET





;-------------------------------------------------
; ᮢ ꥪ ~Test color~
; Format mouse table:
;-------------------------------------------------
PTestCol:
        LD      (IY+1),A		;+0 object
        LD      (IY+4),0
        LD      A,(HL)			; X pos
        INC     HL
        LD      C,A
        ADD     A,(IX+0)		; Pos X from begin screen
        LD      (IY+2),A		;+1 Xo
        LD      A,(HL)			; Y pos
        INC     HL
        LD      B,A
        ADD     A,(IX+1)		; Pos Y from begin screen
        LD      (IY+3),A		;+3 Yo
        LD      (PTestC2+1),BC
        CALL    GetPutA
        PUSH    DE
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        INC     HL
        LD      A,(DE)			; 梥 ப
        LD      C,A
        ;INC     DE
        ;LD      A,(DE)
        ;CPL
        ;LD      B,A
        POP     DE
        PUSH    HL
	; ⥪. ப
        LD      A,(HL)
PTestC1:INC     HL
        LD      (DE),A
        INC     DE
        ;LD      A,(DE)
        ;AND     B
        ;OR      C
	ld	a,c
        LD      (DE),A			; ਡ
        INC     DE
        INC     (IY+4)
        LD      A,(HL)
        OR      A
        JR      NZ,PTestC1
        POP     HL
	; 뢮 2- ப
        PUSH    BC
PTestC2:LD      BC,0
        INC     B			;   ப
        CALL    GetPutA
        POP     BC
        LD      A,(HL)
PTestC3:INC     HL
        LD      (DE),A
        INC     DE
        ;LD      A,(DE)
        ;AND     B
        ;OR      C
	ld	a,c
        LD      (DE),A			; ਡ
        INC     DE
        LD      A,(HL)
        OR      A
        JR      NZ,PTestC3
        INC     HL
        LD      BC,5
        LD      (IY+0),C
        ADD     IY,BC
        RET




;-----------------------------------------------------------
; ࠡ稪 ᮡ⨩ ꥪ ~Test Color~
;-----------------------------------------------------------
ETestCol:
        LD      HL,what
        LD      A,(HL)
        INC     HL
        CP      evMessage
        RET     NZ
        LD      A,(HL)			;+1
        CP      msNewColor
        RET     NZ
        INC     HL
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A
        LD      C,(HL)			; 梥  ᨢ . 梥⮢
        ;INC     HL
        ;LD      B,(HL)
        ;LD      A,B
        ;CP      0FFh
        ;JR      Z,ETestC1
        ;CPL
        ;LD      B,A
        ;LD      A,(color_array+24)	; 梥 . 
        ;AND     B
        ;OR      C
        ;LD      C,A
;ETestC1:
	PUSH    IY
        PUSH    IX
        PUSH    IX
        POP     IY
        IN      A,(PAGE_3)
        PUSH    AF
        LD      A,(page_dial_screen)
        OUT     (PAGE_3),A
        LD      IX,DialData		; ⠡ . . 
        LD      A,C
        PUSH    AF
        LD      A,(IY+2)
        SUB     (IX+0)
        LD      C,A
        LD      A,(IY+3)
        SUB     (IX+1)
        LD      B,A
        CALL    GetPutA
        EX      DE,HL
        POP     AF
        PUSH    AF
        PUSH    IX
        PUSH    HL
        LD      B,(IY+4)
        INC     HL
        LD      (HL),A
        INC     HL
        DJNZ    $-3
        LD      E,(IY+2)
        LD      D,(IY+3)
        LD      L,(IY+4)
        LD      H,1
        POP     IX
        CALL    PutDialLn
        POP     IX
        LD      A,(IY+2)
        SUB     (IX+0)
        LD      C,A
        LD      A,(IY+3)
        SUB     (IX+1)
        INC     A
        LD      B,A
        CALL    GetPutA
        EX      DE,HL
        POP     AF
        PUSH    HL
        LD      B,(IY+4)
        INC     HL
        LD      (HL),A
        INC     HL
        DJNZ    $-3
        LD      E,(IY+2)
        LD      D,(IY+3)
        INC     D
        LD      L,(IY+4)
        LD      H,1
        POP     IX
        CALL    PutDialLn
        POP     AF
        OUT     (PAGE_3),A
        POP     IX
        POP     IY
        RET




;-----------------------------------------------------------
; ࠡ稪 ᮡ⨩ ꥪ ~Pallete Box~
;-----------------------------------------------------------
EPallete:
	ld	hl,what
	ld	a,(hl)
	inc	hl
	cp	evMouseFr
	jp	z,EPmouse
	cp	evKeyboard
	jp	z,EPkeys
	cp	evMessage
	jr	z,EPmess
	cp	evCombKey
	ret	nz
; ⨥ -  
	bit	7,(ix+1)
	jr	nz,EPcomb		; ꥪ 㦥 뤥
	ld	b,(hl)			;+1 what
	inc	hl
	ld	a,(hl)			;+2 what
	cp	56h			;  ࠢ
	jp	z,SetPalBox
	push	ix
	ld	e,(ix+0)		; ࠧ ⠡ "Pallete Box"
	ld	d,0
	add	ix,de
	bit	7,(ix+0)
	pop	ix
	ret	z			;    ꥪ⮢
	cp	54h			;  
	jp	z,SetPalBox
	ld	a,b
	and	00111111b		;  Ctrl, Alt
	ret	nz
	ld	a,(hl)			;+2 what
	cp	15+80h			; Tab  ᪥-+80h
	ret	nz
	; Shift+Tab
	jp	SetPalBox		; 뤥 ।. ꥪ

; ⨥ - ᮮ饭
EPmess:	ld	a,(hl)			;+1 what
	inc	hl
	cp	msNewColor
	ret	nz
	ld	e,(hl)			;+2
	inc	hl
	ld	d,(hl)			;+3
	ld	l,(ix+12)		;  ColList
	ld	h,(ix+13)
	ex	de,hl			; hl=  梥
        ;INC     DE
        ;LD      A,(DE)
        ;AND     (IX+9)
	;JR	Z,EPmess1
        ;DEC     DE
        ;LD      A,(DE)			; ⮣ 梥
        ;AND     (IX+9)			; ᪠  ⥫ ꥪ
        ;LD      B,A
        ;INC     HL
        ;LD      A,(HL)
        ;DEC     HL
        ;AND     (IX+9)
        ;JR      Z,EPmess1
        ;LD      A,(HL)
        ;AND     (IX+9)
        ;CP      B
        ;JR      Z,EPmess1+3
;EPmess1:
	call	ResPalCurs
	ld	(ix+12),l		; hl=  梥
	ld	(ix+13),h
        ;INC     HL
        ;LD      A,(HL)
        ;AND     (IX+9)
	jp	SetPalCurs
        ;CALL    NZ,SetPalCurs
        ;RET

; ⨥ -  
EPcomb:	inc	hl
	ld	de,EPexit
	push	de
	ld	a,(hl)			;+2
	cp	58h			; 
	jp	z,EPup
	cp	52h			; 
	jp	z,EPdown
	cp	54h			; 
	jp	z,EPleft
	cp	56h			; ࠢ
	jp	z,EPright
	pop	de
	ret

;  
EPup:   LD      L,(IX+12)
        LD      H,(IX+13)
        ;INC     HL
        ;LD      A,(HL)
        ;AND     (IX+9)
        ;RET     Z
        ;DEC     HL
        LD      A,(HL)
        AND     (IX+9)
        BIT     7,(IX+9)
        JR      Z,$+6
        RRCA
        RRCA
        RRCA
        RRCA
        SUB     (IX+7)
        RET     C
        JP      EPex

;  
EPdown: LD      B,(IX+8)
        SUB     A
        ADD     A,(IX+7)
        DJNZ    $-3
        LD      C,A
        LD      L,(IX+12)
        LD      H,(IX+13)
        ;INC     HL
        ;LD      A,(HL)
        ;AND     (IX+9)
        ;RET     Z
        ;DEC     HL
        LD      A,(HL)
        AND     (IX+9)
        BIT     7,(IX+9)
        JR      Z,$+6
        RRCA
        RRCA
        RRCA
        RRCA
        ADD     A,(IX+7)
        CP      C
        RET     NC
        JP      EPex

;  
EPleft: LD      L,(IX+12)
        LD      H,(IX+13)
        LD      A,(HL)
        AND     (IX+9)
        BIT     7,(IX+9)
        JR      Z,$+6
        RRCA
        RRCA
        RRCA
        RRCA
        DEC     A
        RET     M
        JP      EPex

;  ࠢ
EPright:ld	b,(ix+8)		; ᫮ 梥.   Y
	xor	a
	add	a,(ix+7)		; ᫮ 梥.   X
	djnz	$-3
	ld	c,a
	ld	l,(ix+12)		; hl= 砫쭮 梥
	ld	h,(ix+13)
	ld	a,(hl)			; . 梥
	and	(ix+9)			; ᪠ 梥⮢
	bit	7,(ix+9)
	jr	z,$+6
	rrca
	rrca
	rrca
	rrca
	inc	a
	cp	c
	ret	nc
EPex:	call	ResPalCurs
	bit	7,(ix+9)
	jr	z,$+6
        RLCA
        RLCA
        RLCA
        RLCA
        LD      C,A
        LD      A,(IX+9)
        CPL
        LD      B,A
        LD      A,(HL)
        AND     B
        OR      C
        LD      (HL),A
        CALL    SetPalCurs
        LD      HL,what
        LD      (HL),evMessage
        INC     HL
        LD      (HL),msNewColor
        INC     HL
        LD      A,(IX+12)
        LD      (HL),A
        INC     HL
        LD      A,(IX+13)
        LD      (HL),A
        call	TransMessUp
	jp	get_fire

; ⨥ - 誠
EPmouse:LD      E,(HL)			; X coord
        INC     HL
        LD      D,(HL)			; Y coord
        LD      A,E
        BIT     7,(IX+2)
        JR      NZ,$+6
        CP      (IX+2)			; Xo pos
        RET     C			; <
        BIT     7,(IX+3)
        RET     NZ
        CP      (IX+3)			; Xi pos
        RET     NC			; >
        LD      A,D
        CP      (IX+4)			; Yo pos list box
        RET     C
        CP      (IX+5)			; Yi pos list box
        RET     NC
        BIT     7,(IX+1)		; sel or nosel
        PUSH    DE
        CALL    Z,SetPalBox		; 뤥 ꥪ
        POP     DE
        LD      HL,EPexit
        PUSH    HL
        LD      L,(IX+12)
        LD      H,(IX+13)
        LD      A,E
        CP      (IX+2)
        RET     Z
        INC     A
        CP      (IX+3)
        RET     Z
        SUB     (IX+2)
        SUB     2
        LD      C,A
        LD      A,D
        CP      (IX+4)			; Yo pos list box
        RET     Z
        INC     A
        CP      (IX+5)			; Yi pos list box
        RET     Z
        SUB     (IX+4)
        SUB     2
        SRL     A
        JR      Z,EPmous1
        LD      B,A
        SUB     A
        ADD     A,(IX+7)
        DJNZ    $-3
EPmous1:LD      E,A
        LD      A,C
        LD      B,-1
        INC     B
	sub	3			;  蠣  ਧ.
        JR      NC,$-3
        LD      A,B
        ADD     A,E
        LD      B,A
        BIT     7,(IX+9)
        JR      Z,$+6
        RLCA
        RLCA
        RLCA
        RLCA
        LD      C,A
        LD      A,(HL)
        AND     (IX+9)
        CP      C
        RET     Z
        LD      A,B
        JP      EPex

; ⨥ -  
EPkeys:	ld	a,(hl)			;+1 what
	bit	7,(ix+1)		; sel or nosel
	ret	nz			; ꥪ 㦥 뤥
	cp	9			; Tab
	jr	z,SetPalBox		; 뤥 ꥪ
	inc	hl
	ld	a,(hl)			;+2 what ᪥-
	cp	(ix+10)			; hot-㪢
	ret	nz
SetPalBox:
	call	MoveObj			; ꥪ  砫 ⠡
	call	ResDialInv		; Reset previos invert
	ld	ix,DialTab+5		; ⠡ ꥪ⮢
	ld	e,(ix+2)		; Xo
	inc	e
	ld	d,(ix+4)		; Y
	ld	a,(ix+6)		; Xi
	sub	e
	ld	c,a			; ਭ 뤥
	call	SetDialInv
EPexit:	ld	hl,what			;  ᮡ
	ld	(hl),evNothing
	ret



;-------------------------------------------------
;   
;-------------------------------------------------
ResPalCurs:
        PUSH    IY
        PUSH    IX
        PUSH    HL
        PUSH    AF
        PUSH    IX
        POP     IY
        LD      IX,DialData		; ⠡ . . 
        LD      L,(IY+12)		; hl= 砫쭮 梥
        LD      H,(IY+13)
        LD      A,(HL)			; . 梥
        AND     (IY+9)			; ᪠  ⥫
        BIT     7,(IY+9)
        JR      Z,$+6
        RRCA
        RRCA
        RRCA
        RRCA
        LD      L,A			; 梥
        LD      B,-1
        INC     B
        SUB     (IY+7)
        JR      NC,$-4
        ADD     A,(IY+7)
        LD      C,A
        ADD     A,A			;1+1=2
        ADD     A,C			;2+1=3  ਧ. 蠣
	inc	a
        LD      C,A
        LD      A,B
        ADD     A,A			;1+1=2  . 蠣
        INC     A
        LD      B,A
        PUSH    BC
        LD      A,(IY+2)
        SUB     (IX+0)
        INC     A
        ADD     A,C
        LD      C,A
        LD      A,(IY+4)
        SUB     (IX+1)
        INC     A
        ADD     A,B
        LD      B,A
        CALL    GetPutA
        IN      A,(PAGE_3)
        PUSH    AF
        LD      A,(page_dial_screen)
        OUT     (PAGE_3),A
        LD      A,""			; ᨬ ࠭
        LD      (DE),A
        INC     DE
        LD      A,L
        LD      (DE),A			; 梥
        POP     AF
        OUT     (PAGE_3),A
        POP     BC
        LD      A,C
        ADD     A,(IY+2)
        INC     A
        LD      E,A
        LD      A,B
        ADD     A,(IY+4)
        INC     A
        LD      D,A
        LD      A,D
        CP      31
        JR      NC,RPalCr
        LD      A,E
        CP      80
        JR      NC,RPalCr
        LD      C,84h			; . 
        PUSH    HL
        RST     08h
        POP     DE			; e=ਡ
        LD      A,""			; ᨬ ࠭
        LD      BC,0181h		;  ᨬ  ਡ⮬
        RST     08h
RPalCr: POP     AF
        POP     HL
        POP     IX
        POP     IY
        RET


;-------------------------------------------------
; 뤥  
;-------------------------------------------------
SetPalCurs:
        PUSH    IY
        PUSH    IX
        PUSH    HL
        PUSH    IX
        POP     IY
        LD      IX,DialData		; ⠡ . . 
        LD      L,(IY+12)		;  ⥪. 梥
        LD      H,(IY+13)
        LD      A,(HL)
        AND     (IY+9)
        BIT     7,(IY+9)
        JR      Z,$+6
        RRCA
        RRCA
        RRCA
        RRCA
        LD      B,-1
        INC     B
        SUB     (IY+7)
        JR      NC,$-4
        ADD     A,(IY+7)
        LD      C,A
        ADD     A,A			;1+1=2
        ADD     A,C			;2+1=3  ਧ. 蠣
	inc	a
        LD      C,A
        LD      A,B
        ADD     A,A			;1+1=2  . 蠣
        INC     A
        LD      B,A
        PUSH    BC
        LD      A,(IY+2)
        SUB     (IX+0)
        INC     A
        ADD     A,C
        LD      C,A
        LD      A,(IY+4)
        SUB     (IX+1)
        INC     A
        ADD     A,B
        LD      B,A
        CALL    GetPutA
        IN      A,(PAGE_3)
        PUSH    AF
        LD      A,(page_dial_screen)
        OUT     (PAGE_3),A
        LD      A,"*"			;  
        LD      (DE),A
        INC     DE
        LD      A,(color_array+24)	; 梥 . 
        LD      (DE),A
        POP     AF
        OUT     (PAGE_3),A
        POP     BC
        LD      A,C
        ADD     A,(IY+2)
        INC     A
        LD      E,A
        LD      A,B
        ADD     A,(IY+4)
        INC     A
        LD      D,A
        LD      A,D
        CP      31
        JR      NC,SPalCr
        LD      A,E
        CP      80
        JR      NC,SPalCr
        LD      C,84h			; . 
        RST     08h
        LD      A,(color_array+24)	; 梥 . 
        LD      E,A
        LD      A,"*"			;  
        LD      BC,0181h		; 1 ᨬ  ਡ⮬
        RST     08h
SPalCr: POP     HL
        POP     IX
        POP     IY
        RET



;-----------------------------------------------------------
; 뤥  ꥪ⮢ ~List Box~, ~Pallete Box~
;-----------------------------------------------------------
PLstBoxI:
	ld	e,(ix+2)		; Xo
	inc	e
	ld	d,(ix+4)		; Y
	ld	a,(ix+6)		; Xi
	sub	e
	ld	c,a			; ਭ 뤥
	call	SetDialInv		; 뤥 
	jp	StLstBoxI		; 㪠⥫ ListBox-







;-----------------------------------------------------------
; ࠡ稪 ᮡ⨩ ꥪ ~Resident1~
;-----------------------------------------------------------
EResident1:
        LD      HL,what			;  ᮡ⨩
        LD      A,(HL)
        INC     HL
        CP      evCommand
        JR      NZ,ERes1
        LD      A,(HL)			;+1
        DEC     HL
        CP      cmSelect
        RET     NZ
        LD      (HL),evNothing
        RET
        ;
ERes1:  CP      evMessage
        RET     NZ
        LD      A,(HL)			;+1 what
        CP      msNewElem
        RET     NZ
        LD      (HL),msNewList
        INC     HL
        PUSH    HL
        LD      L,(HL)			;+2 what  ᯨ᪠ (1..6)
        LD      H,0
        ADD     HL,HL			;1+1=2
        ADD     HL,HL			;2+2=4
        LD      DE,ItemTab		; ⠡
        ADD     HL,DE
        LD      E,(HL)			; de=ItemList1..6
        INC     HL
        LD      D,(HL)
        INC     HL
        LD      C,(HL)			; bc=ColList1..6
        INC     HL
        LD      B,(HL)
        POP     HL
        LD      (HL),E
        INC     HL
        LD      (HL),D
        LD      (AdrCol+1),BC		; ⥪.   ᨢ 梥⮢
        RET


;-------------------------------------------------
; ࠡ稪 ᮡ⨩ ꥪ ~Resident1~
;-------------------------------------------------
EResident2:
        LD      HL,what
        LD      A,(HL)
        INC     HL
        CP      evCommand
        JR      NZ,ERes2
        LD      A,(HL)
        DEC     HL
        CP      cmSelect
        RET     NZ
        LD      (HL),evNothing
        RET
        ;
ERes2:  CP      evMessage
        RET     NZ
        LD      A,(HL)
        CP      msNewElem
        RET     NZ
        LD      (HL),msNewColor
        INC     HL
        LD      C,(HL)			;  ᯨ᪠ 1..6
        LD      B,0
        EX      DE,HL
AdrCol: LD      HL,0			; ⥪.   ᨢ 梥⮢
        ADD     HL,BC			;1+1=2
        ;ADD     HL,BC;?			;2+1=3  
        EX      DE,HL
        LD      (HL),E
        INC     HL
        LD      (HL),D
        RET
